% runmcmc3mixture

% latent class mixed effect modell

% die Matrix Z (bzw. ZG im Unterprogramm) besteht aus einem variablen und einem fixen Teil
% Z(:,1:dd,:) .. variabel .. X2
% Z(:,dd+1:end,:) .. fix .. X1

% Modell: y = X1*alpha + X2*D(1)*betak(1) + .. + X2*D(K)*betak(K) + X2*b + seps  fuer alle i (Index weggelassen)
% mit K .. Anzahl an Klassen
% D(k) .. Dummy fuer Klassenzugehrigkeit
% seps - N(0,sigmaeps^2*I)
% b(i) - N(0,Q(i)); Q(i) = Q(:,:,S(i)); S(i).. gibt Gruppenzug. an


N=size(y,2);
data=1:N;
dd = size(Q0,1); 
d = size(Z,2);
K = size(eta0,2);

% Startwerte:
% alpha0, eta0, seps0, Q0

% Prior:
% pralm,pralinf fuer alpha
% prseps fuer seps
% prQnu, prQS fuer Q (k=1..K)
prQnu = 20;
if (prQnu>(dd+1)/2)
   prQS=Q*(prQnu-(dd+1)/2);
else
   'prQnu zu klein in runmcmc3mixture_neu2'
end   

frac=1;

[alphamc,Smc,IMSmc,LIMSmc,sepsmc,lambmc,postseps,postlamb,etamc,etaMSmc,etapostmc,etapostMSmc,anmc,ancholmc,likMSmc,dlo_miss] = ... 
    mixture3mcmc_neu(y,Z,ZMS,miss,dlo,dlo_out,indexb,indexn,index0,isp_lag_dlo,lag_dir,maxlag,IMS,S,pralm,pralinf,Q0,prseps,seps0,prlamb,lamb0,unit_spec_var,time_spec_var,K,eta0,eta0MS,alpha0,perm,e0,e0MS,frac,M,it0,it0cov,it0b);