function sp = simstateexmixbf(y,eta,ZG,Q,alpha,seps,dd)

% S .. (1 times N) vector of group-number

K = size(eta,2);
T = size(y,1);
d = size(ZG,2);
N = size(y,2);

m = zeros(T,K);
llh = zeros(K,N);

for i=1:N,
   
   ZG1 = squeeze(ZG(:,:,i));
   y1 = y(:,i);
   
   llh1 = -.5*T*(log(2*pi)); 

   alpha1=alpha';
   alpha2(1:dd,1:K) = reshape(alpha1(1:dd*K,1),dd,K);
  % alpha2(dd+1:8*dd,1:K) = alpha1(dd*K+1:dd*(K+7),ones(1,K)); % fr 7 cons.-charact.
   alpha2(dd+1:d,1:K) = alpha1(dd*K+1:dd*(K-1)+d,ones(1,K));

   m = ZG1*alpha2; 
   eps = y1(:,ones(1,K)) - m; 

   for k=1:K,
          
      Vinvk = inv(ZG1(:,1:dd)*(squeeze(Q(:,:,k)))*(ZG1(:,1:dd))' + seps*eye(T));

      llh(k,i) = llh1 +.5*(log(det(Vinvk)))- .5*eps(:,k)'*Vinvk*eps(:,k);   
   
   end
   
end

maxl = max(llh,[],1); % change 1.1.2001
lh = exp(llh - maxl(ones(1,K),:));
p = eta(ones(1,N),:)'.*lh;
sump=sum(p,1);
sp = sum(log(sump)+maxl);
