function [mllogbs, sdrel,loglikq,loglikmc,priorq,priormc,qq,qmc,mu,qmall,qqall] = mlbs_sepsind_MS(alphamc,sepsmc,etamc,etaMSmc,e0,e0MS,etapost,etapostMS,prs,postseps,prlambda,anmc,ancholmc,likMSmc,prm,scale,scale_auto,scale_dum,auto_switch,LIMSmc,y,ZG,ZMS,dd,dMS,lag_dlo,L)
% bridge sampling estimators: random permuations  from MCMC sample of size MMC (number of permuations: see evalq4)

test_IMS_FIX=0; 
%test_IMS_FIX=1;perm=0; %FLAG DAMIT IMS FIX BLEIBT 


%NEU: prQnu, prQS, Qmc, postQnu,postQS, BERGEBEN

%r=size(W,2);
%prQS=matrix r r;
%prQnu scalar

M=size(sepsmc,1); %  laenge MCMC sample
% L=1000;      % laenge q sample
MMC=size(postseps,1);  % laenge der mixture
% MMC=10;  % zum testen
% zufaellige auswahl der MCMC simulationen
nstMS=size(e0MS,1); %number of states
if L<M;
    u = simuni(M,L);
    alphamc=alphamc(u,:);
    sepsmc=sepsmc(u,:);
    etamc=etamc(u,:);
    if nstMS>1
        etaMSmc=etaMSmc(:,:,:,u);
        LIMSmc=LIMSmc(:,:,u);
    end
end
% index fuer simulation von IMS aus prior

% Call = C0;
% call = c0;
% bd = size(c0,1);
bd = 0;
r = size(ZG,2);
nst = size(etamc,2);


% je nach prior aufblasen oder kommentieren:

d=r;
K=nst;

% FLAGzum simulieren von IMS 
% qIMS_prior=(ones(MMC,K)==0);qIMS_lik=(1-qIMS_prior);
qIMS_prior=0;% flag to sample from the prior;
qIMS_lik=1-qIMS_prior; % flag to sample from the likelihood; 

% index1 = [1:d];
% index = reshape(index1(ones(1,K),:)',1,K*d);
% states = [1:K]';
% index2 = reshape(states(:,ones(1,d))',1,K*d);

index1 = [1:dd];
index = reshape(index1(ones(1,K),:)',1,K*dd);
states = [1:K]';
index2 = reshape(states(:,ones(1,dd))',1,K*dd);

[pralm, pralinf] = run_lmc_MS_priorbeta(d,dd,K,dMS,lag_dlo,prm,scale,scale_auto,scale_dum,auto_switch);
%%%%%%%%%%%%%%%%%%%

e0=e0';

r = size(ZG,2);
nst = size(etamc,2);
% kfac = gammaln(nst+1);
ancholsize=size(ancholmc,2);
betasim=zeros(ancholsize,L);

% 1a. construction of q and sampling from q

%    (Wahl von q: mixture approximation)


anmc=anmc';

% 1b. simulate from q 

'1.a: simulate q'

mu = simuni(MMC,L);  
sepssim = 1./gamrnd(squeeze(postseps(mu,1)),1./squeeze(postseps(mu,2)))';

gam = gamrnd(etapost(mu,:)',ones(nst,L));   
sumgam =  sum(gam,1);
etasim =  gam./ sumgam(ones(1,nst),:);
etasimMS=1;


nstMS=size(e0MS,1); %number of states
if nstMS>1
    if size(e0MS,3)==1
        %  xi is assumed to be the same for all processes 
        
        etasimMS=zeros(nstMS,nstMS,L);
        %%for ic=1:nstMS  
        %%     gam = gamrnd(squeeze(etapostMS(ic,:,mu)),ones(nstMS,L));   
        %%    sumgam =  sum(gam,1);
        %%    etasimMS(ic,:,:) =  gam./ sumgam(ones(1,nstMS),:);
        %%end
        
        
    elseif size(e0MS,3)==K
        %  xi is assumed to be different for the various processes 
        
        etasimMS=zeros(nstMS,nstMS,K,L);
        %%for k=1:K
        %%   for ic=1:nstMS  
        %%      gam = gamrnd(squeeze(etapostMS(ic,:,k,mu)),ones(nstMS,L));   
        %%     sumgam =  sum(gam,1);
        %%     etasimMS(ic,:,k,:) =  gam./ sumgam(ones(1,nstMS),:);
        %% end
        %%end
        
    else
        'e0MS and K do not agree in mlbs_sepsind_MS'
    end  
end

index=[1:L];

priorq=zeros(L,1);
priormc=zeros(L,1);
qqall=zeros(L,MMC);
qmall=zeros(L,MMC);
LIMSsim=(zeros(size(LIMSmc))==0);

for m=1:MMC
    if any(m==[1:1000:M]) 
        m
    end
    %   '1.a'
    if any(mu==m)
        lm = sum(mu==m);
      
        eps = randn(ancholsize,lm);
        betasim(:,index(mu==m)) = squeeze(anmc(:,ones(1,lm)*m)) + squeeze(ancholmc(m,:,:))*eps;
        
        T=size(LIMSmc,2);
        if nstMS>1
            
            if size(e0MS,3)==1
                %  xi is assumed to be the same for all processes 
                
                for ic=1:nstMS  
                    ep=etapostMS(ic,:,m)';
                    gam = gamrnd(ep(:,ones(1,lm)),ones(nstMS,lm));   
                    sumgam =  sum(gam,1);
                    etasimMS(ic,:,index(mu==m)) =  gam./ sumgam(ones(1,nstMS),:);
                end
                for k=1:K
                    
                    if ~test_IMS_FIX
                        if qIMS_prior
                             IMS= simstate_ms_prior(lm,squeeze(etasimMS(:,:,index(mu==m))),T);
                            LIMSsim(k,:,index(mu==m))=((IMS-1)==1);
                        elseif qIMS_lik
                            [IMS, pd] = simstate_ms_lik(likMSmc(:,k*ones(1,lm),:,m));
                            IMS=IMS';
                            LIMSsim(k,:,index(mu==m))=IMS-1;  
                            % likelihood normieren
                            likMSmc(:,k,:,m)= squeeze(likMSmc(:,k,:,m))-squeeze(pd(ones(nstMS,1),1,:));
                        end
                        
                        
                    else
                        %% TEST  IMS fix:    statt dessen folgenden Code ausfhren       
                        LIMSsim=LIMSmc;
                    end
         %           priorq(index(mu==m))=priorq(index(mu==m))+prior_IN_log(squeeze(LIMSsim(k,:,index(mu==m)))+1,etasimMS(:,:,index(mu==m)));
                     priorq(index(mu==m))=priorq(index(mu==m))+prior_IN_log(IMS,etasimMS(:,:,index(mu==m)));
                   
                end
               
                    
            elseif size(e0MS,3)==K
                %  xi is assumed to be different for the various processes 
                
                for k=1:K
                    for ic=1:nstMS  
                        ep = etapostMS(ic,:,k,m)';   
                        gam = gamrnd(ep(:,ones(1,lm)),ones(nstMS,lm));   
                        sumgam =  sum(gam,1);
                        etasimMS(ic,:,k,index(mu==m)) =  gam./ sumgam(ones(1,nstMS),:);
                    end
                    if ~test_IMS_FIX
                        if qIMS_prior
                             IMS= simstate_ms_prior(lm,squeeze(etasimMS(:,:,k,index(mu==m))),T);
                            LIMSsim(k,:,index(mu==m))=((IMS-1)==1);
                        elseif qIMS_lik
                            [IMS, pd] = simstate_ms_lik(likMSmc(:,k*ones(1,lm),:,m));
                            IMS=IMS';
                            LIMSsim(k,:,index(mu==m))=IMS-1;    
                                                     % likelihood normieren
                            likMSmc(:,k,:,m)= squeeze(likMSmc(:,k,:,m))-squeeze(pd(ones(nstMS,1),1,:));
    
                          end
                    else
                        %% TEST  IMS fix:    statt dessen folgenden Code ausfhren       
                        LIMSsim=LIMSmc;
                    end          
                  %  priorq(index(mu==m))=priorq(index(mu==m))+prior_IN_log(squeeze(LIMSsim(k,:,index(mu==m)))+1,squeeze(etasimMS(:,:,k,index(mu==m))));
                     priorq(index(mu==m))=priorq(index(mu==m))+prior_IN_log(IMS,squeeze(etasimMS(:,:,k,index(mu==m))));

                    %%                  priormc(index(mu==m))=priormc(index(mu==m)) +prior_IN_log(squeeze(LIMSmc(k,:,index(mu==m)))+1,squeeze(etaMSmc(:,:,k,index(mu==m))));
        
                end
                % if qIMS_prior(m)
                %propose IT from the prior:: prior p(IT|eta) and q identical
                %% 'test prior'                     qqall(index(mu==m),:)= priorq(index(mu==m),ones(1,MMC));
                %end
                
            end   
        else
            LIMSmc=(ones(size(LIMSmc,1),size(LIMSmc,2), L)==1);
            LIMSsim=(zeros(size(LIMSmc))==0);
            
            etasimMS=1;
        end
    end
end


etamcmc=etamc';
sepsmcmc=sepsmc';
alphamcmc=alphamc';

% 1c. evaluate prior and marglik for q sample 


loglikq=zeros(L,1);
loglikmc=zeros(L,1);

priorq = priorq+squeeze(dirichlog(etasim,e0(:,ones(1,L))))';
priorq = priorq+pmultnormlog(betasim,pralm,pralinf)';

priormc = priormc + pmultnormlog(alphamcmc,pralm,pralinf)';
priormc = priormc + squeeze(dirichlog(etamcmc,e0(:,ones(1,L))))';

if all(prs)
    priorq = priorq+squeeze(pinvgamlog(sepssim,prs(ones(1,L),:)'))';  % fuer uniformative sepsi kommentieren
    priormc = priormc+squeeze(pinvgamlog(sepsmc',prs(ones(1,L),:)'))'; % fuer uniformative sepsi kommentieren
end

indexMIX=[1:dd*K];
indexFIX=[K*dd+1:d+(K-1)*dd];
indexMS=[(d+(K-1)*dd+1):(d+(K-1)*dd+dMS*K)];

for m=1:L
    if any(m==[1:1000:M]) 
        m
    end
     loglikq(m) = simstateexstudent_q0_MS(y,etasim(:,m)',ZG,ZMS,LIMSsim(:,:,m),betasim(:,m),indexMIX,indexFIX,indexMS,sepssim(1,m),prlambda,dd);
    
      loglikmc(m) = simstateexstudent_q0_MS(y,etamcmc(:,m)',ZG,ZMS,LIMSmc(:,:,m),alphamcmc(:,m),indexMIX,indexFIX,indexMS,sepsmcmc(m),prlambda,dd);
    
    if nstMS>1
        if size(e0MS,3)==1
            
            priorq(m) =  priorq(m) +dirichlog_trans(etasimMS(:,:,m),e0MS);
            priorIN=0;     
            for k=1:K
                priorIN = priorIN +prior_IN_log(squeeze(LIMSmc(k,:,m))'+1,etaMSmc(:,:,m));
            end
            
            priormc(m)= priormc(m)+priorIN;
            priormc(m) = priormc(m) +dirichlog_trans(etaMSmc(:,:,m),e0MS);
            
        elseif size(e0MS,3)==K
           priorq(m) =  priorq(m) +sum(dirichlog_trans(etasimMS(:,:,:,m),e0MS));
            
            priorIN=0;     
            for k=1:K
               priorIN = priorIN +prior_IN_log(squeeze(LIMSmc(k,:,m))'+1,squeeze(etaMSmc(:,:,k,m)));
            end
            
            priormc(m)= priormc(m)+priorIN;
           priormc(m) = priormc(m) +sum(dirichlog_trans(etaMSmc(:,:,:,m),e0MS));
            
        end
    end
end   

[qq,qmc] = evalq5_lcm_MS (qqall,qmall,betasim,sepssim,etasim,etasimMS,alphamcmc,sepsmcmc,etamcmc,etaMSmc,anmc,ancholmc,postseps,etapost,etapostMS,likMSmc,LIMSsim,LIMSmc,qIMS_prior,qIMS_lik);

ratio = loglikq+priorq-qq;
ratiomax=max(ratio);
ratioexp=exp(ratio-ratiomax);

mllogmi = ratiomax+log(mean(ratioexp)); 
mlsdmi = (L)^(-.5)*exp(log(std(ratioexp))-log(mean(ratioexp)));

sdrel(1)= mlsdmi;

% 1d. berechnen der IS - modellikelihood

% 2a. Evaluate q at the MCMC sample

%etamcmc=etamc(it0+1:it,:)';
%sepsmcmc=sepsmc(it0+1:it)';
%alphamcmc=alphamc(it0+1:it,:)';

% priormc=zeros(L,1);


% 2b. Berechnen der RIS- modelliekihood


r=qmc-loglikmc-priormc;
[ls is]=sort(r);
logc=-r(is(end));

rqp=exp(max(r-max(r),-1e15))';
mllogri = -max(r)-log(mean(rqp));

[omega ac eib abserrn eff] = autocov_alt(rqp,1000);
mlsdri = (abserrn(1,1))^.5/mean(rqp);
sdrel(2)=mlsdri;

% 3. iterative bridge  sampling, starting from ri and mi

maxit=50;
mllogbs=zeros(maxit,2);
mllogbs(1,1)=mllogmi;  
mllogbs(1,2)=mllogri;  

for i=2:maxit
    
    logpostmc=loglikmc+priormc-mllogbs(i-1,2);
    logpostq=loglikq+priorq-mllogbs(i-1,2);
    maxqmc=max([qq logpostq],[],2);
    rq=logpostq-maxqmc-log(exp(log(M)+logpostq-maxqmc)+exp(log(L)+qq-maxqmc));
    maxqmc=max([qmc logpostmc],[],2);
    rmc=qmc-maxqmc-log(exp(log(M)+logpostmc-maxqmc)+exp(log(L)+qmc-maxqmc));
    %mllogbs(i,2)=mllogbs(i-1,2)+log(mean(rq)/mean(rmc));
    mllogbs(i,2)=mllogbs(i-1,2)+max(rq)+log(mean(exp(max(rq-max(rq),-1e15))))-max(rmc)-log(mean(exp(max(rmc-max(rmc),-1e15))));
    
    
    logpostmc=loglikmc+priormc-mllogbs(i-1,1);
    logpostq=loglikq+priorq-mllogbs(i-1,1);
    maxqmc=max([qq logpostq],[],2);
    rq=logpostq-maxqmc-log(exp(log(M)+logpostq-maxqmc)+exp(log(L)+qq-maxqmc));
    maxqmc=max([qmc logpostmc],[],2);
    rmc=qmc-maxqmc-log(exp(log(M)+logpostmc-maxqmc)+exp(log(L)+qmc-maxqmc));
    mllogbs(i,1)=mllogbs(i-1,1)+max(rq)+log(mean(exp(max(rq-max(rq),-1e15))))-max(rmc)-log(mean(exp(max(rmc-max(rmc),-1e15))));
    
    
    
end   

%standard deviations bridge sampling:

rmc=exp(max(rmc-max(rmc),-1e15));
rq=exp(max(rq-max(rq),-1e15));

[omega ac eib abserrn eff] = autocov_alt(rmc',1000);
mlsdbs =(abserrn(1,1)/(mean(rmc)^2)+((std(rq)/mean(rq))^2)/L)^.5;
sdrel(3)=mlsdbs;
