function sst = simulstprior(n,trans,pini)

%simuliere states aus der prior
% function call

p = pini;
fv = zeros(n,length(pini));
fv(1,:) = pini';
K=size(trans,1);
sp = 0;

for i = 2:n
    ext = trans'*p;
    lh = ones(K,1);    % use likelihood function
    p = ext.*lh;
    p = p / sum(p);
    fv(i,:) = p';
end

[n nst] = size(fv);
rnd = rand(n,1);
sst = zeros(1,n);
p = fv(end,:);
st = sum(cumsum(p) < rnd(n)) + 1;          % sampling
sst(n) = st;

for i = (n-1):-1:1
    p = fv(i,:) .* trans(:,st)';
    p = p / sum(p);
    st = sum(cumsum(p) < rnd(i)) + 1;      % sampling
    sst(i) = st;
end

