% SWITCHING, AUTO-REGRESSIVE PARMS SWITCHING (GROUP-SPECIFIC)
ctries=['AUT';'BEL';'DEU';'ESP';'FIN';'FRA';'GRC';'IRL';'ITA';'LUX';'NLD';'PRT';'DNK';'GBR';'SWE';'CHE';'NOR';'AUS';'CAN';'JPN';'USA'];
ctr=[1];
% ctry=[1:12];   %ctry=[3:17 31:34];
ctry=[1:17 31:34]; 
% ctry=[1:4 6 8:14 16 31:34];
% ctry=[1:15 17 32:34];
% ctry=[5]

clear *mc;
index0=[];
% gr_fix=0; %flag to fix the groups a priori NOT FULLY IMPLEMENTED
% 
not_switch=0; %flag to restrict model to non-switching  FULLY IMPLEMENTED by Sylvia F-S, Juli 2003
auto_switch=1; %flag to make autoregressive parameters group- and state-specific (needed for prior definition)

true=0; %flag to start with true values of I_t and of parameters (if 1), to start with general values (if 0)
maxlag=4; %maximum endogenous or exogenous variables
for K=[2];['K=' int2str(K)]
    for lag_dlo=[1]; ['lag=' int2str(lag_dlo)] %lag endogenous variable
        lag_dir=0; %lag exogenous variable
        
        % est=1; %flag to standardize each series before estimation, NOT NEEDED ANY MORE with unit-specific variances
        eta_different=1; %flag for different transition probabilities of each group-specific I_t, 0=equal trans. probs. for group-specific I_t
        %eta_different=0; %flag for different transition probabilities of each group-specific I_t, 0=equal trans. probs. for group-specific I_t
        
        
        unit_spec_var=1; %flag to model unit specific error variance e_it~N(0,sigma^2/lambda_i)
        time_spec_var=0; %flag to model time and unit-specific error variances e_it~N(0,sigma^2/lambda_it)
        dum_out=0; %flag to model dummies as (outlying) missing values 
        
        run_model4_endswit;
        %test_run_model4;
        
        prm=0.0; %mean of group-specific parameter if I_t==1;
        scale=0.25; % prior inf. for group-specific parms gleich wie sylvia (Identittsmatrix), scale kleiner--info kleiner
        scale_auto=1; % prior inf. for lagged endogenous variables
        scale_dum=0.01; % prior inf. for dummy variables
        
        tic
        run_lcm_MS;
        toc
%         save(['model_MS_end' int2str(lag_dlo) '_ex' int2str(lag_dir) '_long_' ctries(ctr,:) '_78']);
        save(['IPmodel_K' int2str(K) '_end' int2str(lag_dlo) '_ex' int2str(lag_dir) '_7802_autoswit']);
        clear functions
        % ctr=ctr+1;
    end
end

