function [qq,qmc] = evalq5_lcm_MS(qqall,qmall,betasim,sepssim,etasim,etasimMS,betamcmc,sepsmcmc,etamcmc,etaMSmc,anmc,ancholmc,postseps,etapost,etapostMS,likMSmc,LIMSsim,LIMSmc,qIMS_prior,qIMS_lik);

% Random permutation sampler 
% input qqall, qmall aus der auswertung von q (M times MMC), vergleichbar eval5dd

MMC=size(anmc,2);
L=size(etasim,2);
nst=size(etasim,1);
nstMS=size(etasimMS,1);
NIMSsim=zeros(nstMS,nstMS,L,nst);
NIMSmc=NIMSsim;

% deterime counts for prior evaluation
if nstMS>1;
    for k=1:nst
        [dum1,NIMSsim(:,:,:,k)] = simxi_ms(squeeze(LIMSsim(k,:,:))+1,zeros(2,2,size(LIMSsim,3)));
        [dum1,NIMSmc(:,:,:,k)] = simxi_ms(squeeze(LIMSmc(k,:,:))+1,zeros(2,2,size(LIMSsim,3)));
    end
end 
for l=1:MMC
    
    
    infcholp=inv(squeeze(ancholmc(l,:,:))); %sigma^-1=infchol'*infchol
    
    qmall(:,l) = qmall(:,l) + pmultnormchol(betamcmc,squeeze(anmc(:,l*ones(1,L))),infcholp)';
    qmall(:,l) = qmall(:,l) + squeeze(dirichlog(etamcmc,etapost(l*ones(1,L),:)'))';
    qmall(:,l) = qmall(:,l) + squeeze(pinvgamlog(sepsmcmc,postseps(l*ones(1,L),:)'))';
    
    qqall(:,l) = qqall(:,l) + pmultnormchol(betasim,squeeze(anmc(:,l*ones(1,L))),infcholp)';
    qqall(:,l) = qqall(:,l) + squeeze(dirichlog(etasim,etapost(l*ones(1,L),:)'))';
    qqall(:,l) = qqall(:,l) + squeeze(pinvgamlog(sepssim,postseps(l*ones(1,L),:)'))';
    if nstMS>1
        if size(etapostMS,3)==1
            qqall(:,l) = qqall(:,l)+squeeze(dirichlog_trans(squeeze(etasimMS),squeeze(etapostMS(:,:,l*ones(1,L)))));
            qmall(:,l) = qmall(:,l)  +squeeze(dirichlog_trans(squeeze(etaMSmc),squeeze(etapostMS(:,:,l*ones(1,L)))));
        end    
        for k=1:nst
  
            if size(etapostMS,3)>1
                qqall(:,l) = qqall(:,l)+squeeze(dirichlog_trans(squeeze(etasimMS(:,:,k,:)),squeeze(etapostMS(:,:,k,l*ones(1,L)))));
                qmall(:,l) = qmall(:,l)  +squeeze(dirichlog_trans(squeeze(etaMSmc(:,:,k,:)),squeeze(etapostMS(:,:,k,l*ones(1,L)))));
                %evaluate at Imc
               
                if qIMS_prior
    %                lmc=(L-MMC+l);qqall(:,l) = qqall(:,l)+squeeze(sum(sum(NIMSsim(:,:,:,k).*log(squeeze(etaMSmc(:,:,k,lmc*ones(1,L)))))));
                     qqall(:,l) = qqall(:,l)+squeeze(sum(sum(NIMSsim(:,:,:,k).*log(squeeze(etasimMS(:,:,k,:))))));
                     qmall(:,l) = qmall(:,l)+squeeze(sum(sum(NIMSmc(:,:,:,k).*log(squeeze(etaMSmc(:,:,k,:))))));
                elseif qIMS_lik
                    zerone=cat(1,zeros(1,size(LIMSsim,2),size(LIMSsim,3)),ones(1,size(LIMSsim,2),size(LIMSsim,3)));
                    qqall(:,l) = qqall(:,l)+squeeze(sum(sum(squeeze(likMSmc(:,k,:,l*ones(1,L))).*(LIMSsim(k*ones(nstMS,1),:,:)==zerone))));
                    qmall(:,l) = qmall(:,l)+squeeze(sum(sum(squeeze(likMSmc(:,k,:,l*ones(1,L))).*(LIMSmc(k*ones(nstMS,1),:,:)==zerone))));
                else
                    'error eval q'
                end
         
            elseif size(etapostMS,3)==1
                if qIMS_prior
                     qqall(:,l) = qqall(:,l)+squeeze(sum(sum(NIMSsim(:,:,:,k).*log(squeeze(etasimMS(:,:,k,:))))));
                     qmall(:,l) = qmall(:,l)+squeeze(sum(sum(NIMSmc(:,:,:,k).*log(squeeze(etaMSmc(:,:,k,:))))));
               elseif qIMS_lik
                    zerone=cat(1,zeros(1,size(LIMSsim,2),size(LIMSsim,3)),ones(1,size(LIMSsim,2),size(LIMSsim,3)));
                    qqall(:,l) = qqall(:,l)+squeeze(sum(sum(squeeze(likMSmc(:,k,:,l*ones(1,L))).*(LIMSsim(k*ones(nstMS,1),:,:)==zerone))));
                    qmall(:,l) = qmall(:,l)+squeeze(sum(sum(squeeze(likMSmc(:,k,:,l*ones(1,L))).*(LIMSmc(k*ones(nstMS,1),:,:)==zerone))));
                else
                    'error eval q'                
                end  
            end
            % compute 

          
        end
    end
end

qmax= max(qmall,[],2);
qmc=qmax+log(sum(exp(max(qmall-qmax(:,ones(1,MMC)),-1e15*ones(L,MMC))),2));

qmax= max(qqall,[],2);
qq= qmax+log(sum(exp(max(qqall-qmax(:,ones(1,MMC)),-1e15*ones(L,MMC))),2));

qmc=qmc-log(MMC);
qq=qq-log(MMC);
