function [fv,sp] = filtvert_MIX_MS(yboom,yrec,eta,sig,lag_dlo);

% FILTVERT filterverteilung
% function call

n = size(yboom,1)+1;
nst = 2;
p = ones(nst,1)/nst;
fv = zeros(n+lag_dlo,nst);
lh=zeros(n-1,nst);
maxl=zeros(n-1,nst);

[lh  maxl] = multlikeli_MS2(yrec,yboom,sig);    % use likelihood function
fv(1,:) = p';
sp = 0;

for i=2:2+lag_dlo-1
    fv(i,:) = p'*eta;
end   

for i = 2+lag_dlo:n+lag_dlo
    ext = eta'*p;
    p = ext.*lh(i-(lag_dlo+1),:)';
    sp = sp + log(sum(p))+maxl(i-(lag_dlo+1));
    p = p / sum(p);
    fv(i,:) = p';
end

