% runmcmc3mixture_ml
fid=fopen('bf_groupswitch_rev.out','a');
% latent class mixed effect modell - berechnen bayes factor aus vorhandenen simulationen
% (workspace aktiv)
% L=2000;
prlambda=prlamb(1);
[mllogbs, sdrel,loglikq,loglikmc,priorq,priormc,qq,qmc,mu,qmall,qqall] = mlbs_sepsind_MS(alphamc,sepsmc,etamc,etaMSmc,e0,e0MS,etapostmc,etapostMSmc,prseps,postseps,prlambda,anmc,ancholmc,likMSmc,prm,scale,scale_auto,scale_dum,auto_switch,LIMSmc,y,Z,ZMS,dd,dMS,lag_dlo,L);

ergmiran=[mllogbs(1,1) sdrel(1) mllogbs(1,1)-5*sdrel(1) mllogbs(1,1)+5*sdrel(1)] %importance
ergriran=[mllogbs(1,2) sdrel(2) mllogbs(1,2)-5*sdrel(2) mllogbs(1,2)+5*sdrel(2)] %reciprocal imp.
ergbsranmi=[mllogbs(end,1) sdrel(3) mllogbs(end,1)-5*sdrel(3) mllogbs(end,1)+5*sdrel(3)]  %bridge,e0MS
ergbsranri=[mllogbs(end,2) sdrel(3) mllogbs(end,2)-5*sdrel(3) mllogbs(end,2)+5*sdrel(3)]  %bridge,e0MS

if and(~not_switch,~auto_switch)
    t=['model_K' int2str(K) 'end' int2str(lag_dlo) '_ex' int2str(lag_dir) '_9902               ' 'imp ' num2str(ergmiran,'%6.4f %6.4f %6.4f') ' r.imp ' num2str(ergriran,'%6.4f %6.4f %6.4f') ' bsmi ' num2str(ergbsranmi,'%6.4f %6.4f %6.4f') '\n'];
elseif and(~not_switch,auto_switch)
    t=['model_K' int2str(K) 'end' int2str(lag_dlo) '_ex' int2str(lag_dir) '_9902_autoswit      ' 'imp ' num2str(ergmiran,'%6.4f %6.4f %6.4f') ' r.imp ' num2str(ergriran,'%6.4f %6.4f %6.4f') ' bsmi ' num2str(ergbsranmi,'%6.4f %6.4f %6.4f') '\n'];
elseif and(not_switch,~auto_switch)
    t=['model_K' int2str(K) 'end' int2str(lag_dlo) '_ex' int2str(lag_dir) '_9002_nonswit_ndm       ' 'imp ' num2str(ergmiran,'%6.4f %6.4f %6.4f') ' r.imp ' num2str(ergriran,'%6.4f %6.4f %6.4f') ' bsmi ' num2str(ergbsranmi,'%6.4f %6.4f %6.4f') '\n'];
elseif and(not_switch,auto_switch)
    t=['model_K' int2str(K) 'end' int2str(lag_dlo) '_ex' int2str(lag_dir) '_9002_nonswitautogr_ndm ' 'imp ' num2str(ergmiran,'%6.4f %6.4f %6.4f') ' r.imp ' num2str(ergriran,'%6.4f %6.4f %6.4f') ' bsmi ' num2str(ergbsranmi,'%6.4f %6.4f %6.4f') '\n'];
    
end

fprintf(fid,t);
fclose(fid)

clear *post* loglik 
clear qnorm loglikq loglikmc priorq priormc qq qmc %ergmiran ergriran ergbsran
clear mllogbs sdrel
clear functions
