[data ctry]=xlsread('ind_prod_qrtly70q1_03q2.xls'); %
%E15 EUR AUT BEL DEU ESP FIN FRA GRC IRL ITA NLD PRT DNK GBR SWE CHE NOR AUS CAN JPN USA
%1   2   3   4   5   6   7   8   9   10  11  12  13  14  15  16  17  18  19  20  21  22
data=log(data);
y_gr=(data(2:end,:)-data(1:end-1,:))*100;
% y_gr=y_gr- kron(ones(size(y_gr,1),1),mean(y_gr,1));
ctry=ctry(1,:);
ctries_sel=['AUT';'BEL';'DEU';'ESP';'FIN';'FRA';'GRC';'IRL';'ITA';'LUX';'NLD';'PRT';'DNK';'GBR';'SWE';'CHE';'NOR';'AUS';'CAN';'JPN';'USA'];
cctries=cellstr(ctries_sel);
ind_ctry=find(sum(strcmp(ctry(ones(size(ctries_sel,1),1),:),cctries(:,ones(1,size(ctry,2)))),1));


ngr=6;
nc=2;
nr=ngr/nc;
nctr=size(data,2);
nfig=ceil(nctr/ngr);

cend=2003+2/4;
nobs=size(data,1);
cal= cend-[nobs:-1:1]./4;

obs_per=find((cal>=1978).*(cal<2003)); %choose sample period, contains the respective rows of original matrix
cal=cal(obs_per);
data=data(obs_per,:);
y_gr=y_gr(obs_per(1:end-1),:);

% for f=1:nfig;
%     figure(gcf+1)
%     for j=1:ngr
%         if (f-1)*ngr+j<=nctr
%             subplot(nr,nc,j)
%             plot(cal,data(1:end,(f-1)*ngr+j))
%             xlabel(ctry(1,(f-1)*ngr+j))
%             ax1=gca;
%             set(ax1,'XLim',[cal(1) cal(end)])
%             ax2=axes('Position',get(ax1,'Position'),'XAxisLocation','top','YAxisLocation','right','Color','none');
%             set(ax2,'XLim',[cal(1) cal(end)],'XTickLabel',' ')
%             %     if k==1 set(ax2,'XLim',[cal(1) cal(end)],'YLim',[-5 5]); end
%             line(cal(2:end),y_gr(:,(f-1)*ngr+j),'Parent',ax2,'Color','k')
%             hold on
%             line(cal(1:end),zeros(size(data,1),1),'Parent',ax2,'Color','k')
%         end
%     end
% end

figure(gcf+1)
plot(cal(2:end),y_gr(:,ind_ctry))
axis([cal(2) cal(end) min(min(y_gr(:,ind_ctry),[],1))-0.1 max(max(y_gr(:,ind_ctry),[],1))+0.1])