function sp  = simstateexstudent_q0_MS(y,eta,ZG,ZMS,IMS,alpha,indexMIX,indexFIX,indexMS,seps,prlambda,dd)

% S .. (1 times N) vector of group-number

K = size(eta,2);
T = size(y,1);
d = size(ZG,2);
dMS = size(ZMS,2);
N = size(y,2);
if size(IMS,1)<K;
    IMS=IMS(ones(K,1),:);
end
IMStr=IMS';

m = zeros(T,K,N);
llh = zeros(K,N);
%ZG = squeeze(ZG);
%ZMS = squeeze(ZMS);
%Vinvk = zeros(T,T,K);
fv =zeros(N,K);
eps = zeros(T,K,N);

if prlambda>1000
llh1 = -.5*T*(log(2*pi)); % normal
else
llh1 = -0.5*T*log(pi)+prlambda*0.5*log(prlambda)+gammaln(0.5*(prlambda+T))-gammaln(0.5*prlambda); %STUDENT
end

alpha1=alpha';
alpha2= reshape(alpha1(indexMIX),1,dd,1,K);
% alpha2(dd+1:8*dd,1:K) = alpha1(dd*K+1:dd*(K+7),ones(1,K)); % fr 7 cons.-charact.
alpha2(1,dd+1:d,1,1:K) = alpha1(1,indexFIX,1,ones(1,K));
m1 = permute([sum(ZG(:,:,:,ones(1,K)).*alpha2(ones(T,1),:,ones(N,1),:),2)],[1 4 3 2]); 

if dMS>0;
    alpha3=reshape(alpha1(indexMS),1,dMS,1,K);
    m1= m1 + (permute([sum(ZMS(:,:,:,ones(1,K)).*alpha3(ones(T,1),:,ones(N,1),:),2)],[1 4 3 2])).*(IMStr(:,:,ones(N,1))-1);
end

ytr= reshape(y,T,1,N);
eps = ytr(:,ones(1,K),:) - m1; 

if prlambda>1000

     llh = llh1 -.5*(T*log(seps) + permute(sum(eps.^2,1),[2 3 1])/seps);     %normal
 else
     llh = llh1  -.5*T*log(seps)-0.5* permute((prlambda+T)*log( prlambda+sum(eps.^2,1)/seps),[2 3 1]);   %STUDENT
 end
 

maxl = max(llh);
lh = exp(llh - maxl(ones(1,K),:));

p = eta(ones(N,1),:)'.*lh;
sp = sum(log(sum(p,1))+maxl,2);
